package com.zatchu.chimes;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageButton;
import android.widget.ListAdapter;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.csounds.CsoundObj;
import com.csounds.CsoundObjCompletionListener;

public class ChimesActivity extends Activity implements
		CsoundObjCompletionListener {
	ToggleButton startStopButton = null;
	CsoundObj csound = null;
	File csd = null;
	ArrayList<SeekBar> sliders = new ArrayList<SeekBar>();
	ArrayList<String> str = new ArrayList<String>();
	ListAdapter adapter;
	protected Handler handler = new Handler();
	boolean running = false;
	String errorMessage;
	private static final String TAG = "Chimes";

	public void csoundObjComplete(CsoundObj csoundObj) {
		handler.post(new Runnable() {
			public void run() {
				startStopButton.setChecked(false);
				if (csound.getError() != 0)
					//displayError(csound.getError());
				running = false;
			}
		});
	}


	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		try {
			csound.stopCsound();
		} catch (Exception e) {
			Log.e("error", "could not stop csound");
		}

	}

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		File externalFilesDir = getExternalFilesDir(null);

		try {
			if (externalFilesDir.exists()) {
				csd = new File(externalFilesDir, "ChimePad.csd");
				File newtype = new File(externalFilesDir, "soundin.0");
				if (newtype.exists()) {
				} else {
					String staticPath = externalFilesDir.getAbsolutePath();
					copyAsset("ChimePad.csd", staticPath);
					copyAsset("soundin.1", staticPath);
					copyAsset("soundin.2", staticPath);
					copyAsset("soundin.3", staticPath);
					copyAsset("soundin.4", staticPath);
					copyAsset("soundin.5", staticPath);
					copyAsset("soundin.6", staticPath);
				}
			} else {
				Toast.makeText(getApplicationContext(),
						"Please mount storage and try again. Exiting...", 3)
						.show();
				finish();
			}
		} catch (IOException e) {
			Log.e(TAG, "DistList onCreate");
		} catch (NullPointerException e) {
			Toast.makeText(getApplicationContext(),
					"Please mount storage and try again. Exiting...", 3)
					.show();
			finish();
		}

		sliders.add((SeekBar) findViewById(R.id.seekBar1));
		sliders.add((SeekBar) findViewById(R.id.seekBar2));
		sliders.add((SeekBar) findViewById(R.id.seekBar3));

		startStopButton = (ToggleButton) findViewById(R.id.onOffButton);
		startStopButton
				.setOnCheckedChangeListener(new OnCheckedChangeListener() {
					public void onCheckedChanged(CompoundButton buttonView,
							boolean isChecked) {
						if (csd == null) {
							buttonView.toggle();
							return;
						}
						Log.d("CSD", csd.getAbsolutePath());
						if (isChecked) {
							csound = new CsoundObj();

							String channelName;
							for (int i = 0; i < 3; i++) {
								channelName = "slider" + (i + 1);
								csound.addSlider(sliders.get(i), channelName,
										0., 1.);
							}
							csound.addCompletionListener(ChimesActivity.this);
							csound.startCsound(csd);
							TextView tv = (TextView) findViewById(R.id.textView7);
							tv.setText("Chimes playing...");

						} else {
							csound.stopCsound();
							TextView tv = (TextView) findViewById(R.id.textView7);
							tv.setText("Chimes stopped...");
							running = false;
						}
					}
				});
		sliders.get(0).setProgress(50);
		sliders.get(2).setProgress(100);
		startStopButton.setChecked(true);

	}

	private void copyAsset(String assetFilename, String staticPath)
			throws IOException {

		// Open your local db as the input stream
		InputStream myInput = getAssets().open(assetFilename);

		// Open the empty db as the output stream
		OutputStream myOutput = new FileOutputStream(staticPath + "/"
				+ assetFilename);

		// transfer bytes from the inputfile to the outputfile
		byte[] buffer = new byte[2048];
		int length;
		while ((length = myInput.read(buffer)) > 0) {
			myOutput.write(buffer, 0, length);
		}

		// Close the streams
		myOutput.flush();
		myOutput.close();
		myInput.close();

	}
}